extern crate argparse;

mod config;
mod screen;

use self::argparse::{ArgumentParser, Store};
use std::process::{exit};

fn main() {

    // TODO parse args
    // Pass (optional) config file loc from them
    // Get config
    // Overlay other options from config struct

    // Argument handling
    let mut config_location = config::default_config_file();
    let config_help = format!("Config file location, default {}", config_location);
    let mut difficulty = String::from("");

    {
        let mut ap = ArgumentParser::new();
        ap.set_description("A Fallout terminal minigame inspired game.");
        ap.refer(&mut difficulty)
            .add_option(&["--difficulty"], Store, "The game's difficulty (veryEasy [default], \
                                                   easy, average, hard, or veryHard)");

        ap.refer(&mut config_location)
            .add_option(
                &["--config"],
                Store,
                config_help.as_str()
            );
        ap.parse_args_or_exit();
    }

    match difficulty.as_str() {
        "" | "veryEasy" => {
            println!("veryEasy");
        },
        _ => {
            println!("Invalid difficulty, see --help");
            exit(1)
        }
    }
    // Config file handling
    let mut config = config::load_config_file(config_location);
    println!("{:?}", config);

    let screen = screen::init_screen();
    screen.intro();
    screen.w.refresh();
    screen.w.getch();
    screen.end_window();
}
